#ifndef disco_h
#define disco_h

#include <Arduino.h>

#define SPI_time 10      // задержка spi
#define DLIT   100      // константы длительностей для программ динамического вывода
#define DLITV  9

//======================================================================================
// символы знакогенератора
const static uint8_t seg7Chartable[] = {
     0b01111110,      // 0
     0b00110000,      // 1
     0b01101101,      // 2
     0b01111001,      // 3
     0b00110011,      // 4
     0b01011011,      // 5
     0b01011111,      // 6
     0b01110000,      // 7
     0b01111111,      // 8
     0b01111011,      // 9
     0b01100011,      // символ "°" градус Цельсия
     0b01001110,      // "C"
};
//======================================================================================

//class lcclok
class MAX7221 {
  private :
    /* Отправить на устройство одну команду */
    void spi_transfer(uint8_t data);
    /* Вывод для передачи данных */
    uint8_t SPI_MOSI;
    /* Вывод синхросигнала */
    uint8_t SPI_SCK;
    /* Вывод для выбора микросхемы */
    uint8_t SPI_CS;
	/* начало общения */
    void spi_go();
	/* конец общения */
    void spi_end();
	/* задежка для создания эффектов индикации */
    void zaderj(uint8_t dlit);
	/* очистка индикатора слева направо */
    void ochisL(uint8_t pomt);
	/* очистка индикатора справа налево */
    void ochisR(uint8_t pomt);

  public :
    /* задаём выводы для подключения  */
    MAX7221(uint8_t dataPin, uint8_t clkPin, uint8_t csPin);
	/* определяем яркость */
    void yark_DISPL(char yarkost);
	/* загрузка буфера для непосредственной индикации */
    void indic(uint8_t buf1, uint8_t buf2, uint8_t buf3, uint8_t buf4, bool dot2, bool dot4);
	/* очистка дисплея */
    void clear_DISPL(void);
	/* Функция передачи двух пакетов по 8 бит по протоколу SPI */
    void LOAD_displ(void);
	/* загрузка буфера (для эффектов анимации индикатора) */
    void LoadBU(uint8_t buf1, uint8_t buf2, uint8_t buf3, uint8_t buf4, bool dot2, bool dot4);
	/* выезд буфера справо налево */
    void go_left(void);
	/* выезд буфера слево направо */
    void go_right(void);
	/* выезд буфера сверху вниз */
    void go_down(void);
	/*  выезд буфера снизу вверх */
    void go_up(void);
	/*  наложение слева направо */
    void imposeR(void);
	/* наложение справа налево */
    void imposeL(void);
	/* эффект колеса на всех индикаторах */
    void koleso(uint8_t pomt);
	/* эффект колеса при изменении одного разряда */
    void effect(uint8_t pomt);
	
};

#endif
